//*****************************************************************
//                         йDIY֮                       //
//                         һDIY                     //
//                        س  ԭƷ                     //
//                             2012.10.8                         //
//*****************************************************************
#include "reg52.h"
#include "intrins.h"
//-------궨---------
#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long
#define Cref 2200      //׼ֵ(λpF)
#define LCD_DATA P0    //LCDݿ(8λ)
//-------I/O--------
sbit LCD_BUSY = P0^7; //LCDæź
sbit LCD_RS   = P1^0; ///ѡ(=1,=0)
sbit LCD_RW   = P1^1; ///дѡ(д=0,=1)
sbit LCD_EN   = P1^2; //ʹź
sbit K1_F_LC   = P1^3; //F/LCѡť(),([̧]=0LC,[]=1F)
sbit K2_L_C    = P1^4; //L/Cѡť()([̧]=0C,[]=1L)
sbit K3_Eb_Es  = P1^6; //ѡť(),([̧]=0,[]=1)
sbit K4_FLC_EC = P3^6; //FLCEC()ѡť()(ÿһ,תһ)
sbit K5_Calib  = P3^7; //ֹУ()ť()(ֵ)
sbit Dischg    = P1^5; //ʱĳŵƶ˿(=0ŵ,=1)
//-------ȫֱ--------
bit  FLC_EC_Flag;  //־(=0FLC,=1)
u8   Measure_Flag; //־(=1,=2,=3Ƶ,=4С,=5)
u8   Lref;         //׼ֵ(λuH)(ԭû)
u16  T0_times;     //T0жϼԤֵ(ÿ50msһ),F=20(1s),LC=10(0.5s)
u16  Timer0_Num;   //T0
u16  Timer1_Num;   //T1
u32  Frequency0;   //Ƶ0(δӱԪʱƵ)
u32  Frequency1;   //Ƶ1(뱻ԪʱƵ)
u32  Cx;           //
u32  Lx;           //
u32  ECx_H;        //()
u32  ECx_L;        //(С)
//------xnη------------
u32 power(u8 x,u8 n)
{
    u8 i;
    u32 j = 1;
    if(n == 0)
    {
        return 1;
    }
    else
    {
        for(i=0; i<n; i++)
        {
            j *= x;
        }
        return j;
    }
}
//----ʱn(12M,12Tģʽ,һָ=1us)---
//----1ms=(ת3ָ+ָ)*200----
void Delay_ms(u8 n)
{
    u8 i,j;
    for(i=0; i<n; i++)
    {
        for(j=0; j<200; j++)
        {
            _nop_();
            _nop_();
        }
    }
}
//------LCD1602æ־λ------
void Check_busy(void)
{
    do
    {
        LCD_EN=0;
        LCD_RS=0;
        LCD_RW=1;
        LCD_DATA=0xFF;
        LCD_EN=1;
    }
    while(LCD_BUSY==1);
    LCD_EN=0;
}
//------LCD1602дָ------
void Write_Command(u8 cmd)
{
    Check_busy();
    LCD_RS=0;
    LCD_RW=0;
    LCD_DATA=cmd;
    LCD_EN=0;
    LCD_EN=1;
    LCD_EN=0;
}
//------LCD1602д------
void Write_Data(u8 dat)
{
    Check_busy();
    LCD_RS=1;
    LCD_RW=0;
    LCD_DATA=dat;
    LCD_EN=0;  //С1usʱ,ʱ
    LCD_EN=1;
    LCD_EN=0;
}
//-----LCD1602дַ------
//---x=(0~15); y=(0,1)
//---ָλÿʼд,ֱĻʾ
void LCD_Write_String(u8 y,u8 x,u8 *Data)
{
    if(y==0)      //һ
    {
        if(x<16)
        {
            Write_Command(0x80+x);  //0x80 + һʼַ
            for(; x<16&&*Data!='\0'; x++)   //'\0'ַ־
            {
                Write_Data(*(Data++));
            }
        }
    }
    if(y==1)      //ڶ
    {
        if(x<16)
        {
            Write_Command(0xc0+x);          //0xc0 + ڶʼַ
            for(; x<16&&*Data!='\0'; x++)   //'\0'ַ־
            {
                Write_Data(*(Data++));
            }
        }
    }
}
//------LCD1602д------
//x=(0~15); y=(0,1);ȡͺlengthʾָλ(ȫʾlength=10)
//ע˺ֻ֧,ʼ+length>15ʱʾ,ܵʾ
void LCD_Write_Long(u8 y,u8 x,u8 length,u32 Data)
{
    u8 i,k;
    if(length>10)
    {
        length = 10;
    }
    if(length<10)
    {
        Data = Data%power(10,length);
    }
    if(y==0)     //һ
    {
        Write_Command(0x80+x);      //0x80 + һʼַ
        for(i=0; i<length; i++)
        {
            k = (u8)(Data/power(10,length-1-i));
            Data = Data%power(10,length-1-i);
            Write_Data(k+0x30);
        }
    }
    if(y==1)     //ڶ
    {
        Write_Command(0xc0+x);      //0xc0 + ڶʼַ
        for(i=0; i<length; i++)
        {
            k = (u8)(Data/power(10,length-1-i));
            Data = Data%power(10,length-1-i);
            Write_Data(k+0x30);
        }
    }
}
//------LCD1602д,ָСλ-------
//x=(0~15); y=(0,1);ȡͺlengthʾָλ(ȫʾlength=10)
//ע˺ֻ֧,ʼ+length>15ʱʾ,ܵʾ
//pot:Сʾ :1234567 pot=2ʱʾΪ12345.67
void LCD_Write_LongPoint(u8 y,u8 x,u8 length,u8 pot,u32 Data)
{
    u8 i,j,k;
    if(length>10)
    {
        length = 10;
    }
    if(length<10)
    {
        Data = Data%power(10,length);
    }
    if(y==0)    //һ
    {
        j=0;
        Write_Command(0x80+x);      //0x80 + һʼַ
        for(i=0; i<=length; i++)
        {
            if(i==(length-pot))
            {
                Write_Data(0x2e);   //С
                Write_Command(0x80+x+i+1);
            }
            else
            {
                k = (u8)(Data/power(10,length-1-j));
                Data = Data%power(10,length-1-j);
                Write_Data(k+0x30);
                j++;
            }
        }
    }
    if(y==1)    //ڶ
    {
        j=0;
        Write_Command(0xc0+x);      //0xc0 + ڶʼַ
        for(i=0; i<=length; i++)
        {
            if(i==(length-pot))
            {
                Write_Data(0x2e);   //С
                Write_Command(0xc0+x+i+1);
            }
            else
            {
                k = (u8)(Data/power(10,length-1-j));
                Data = Data%power(10,length-1-j);
                Write_Data(k+0x30);
                j++;
            }
        }
    }
}
//------LCD1602---------
void LCD_Clear(void)
{
    Write_Command(0x01);
}
//------LCD1602ʼ-----
void LCD1602_Init(void)
{
    Delay_ms(15);
    Write_Command(0x38);   //16x2ʾ,8λ
    Write_Command(0x0c);   //ʾ
    Write_Command(0x06);   //ACԶ1,ַд
    LCD_Clear();
}
//------жϲ-------
void Get_Measure_Flag(void)
{
    if(FLC_EC_Flag==0)    //FLCѡ־λ
    {
        if(K1_F_LC==1)
        {
            Measure_Flag = 3;   //Ƶ
            T0_times = 20;  //T0ʱ1s
        }
        else
        {
            if(K2_L_C==0)
            {
                Measure_Flag = 1; //
            }
            else
            {
                Measure_Flag = 2;
            }
            T0_times = 10;  //T0ʱ0.5s
        }
    }
    else
    {
        TR0 = 0;        //رղƵ(LC)
        ET0 = 0;
        if(K3_Eb_Es==0)
        {
            Measure_Flag = 4;  //С
        }
        else
        {
            Measure_Flag = 5;  //
        }
    }
}
//------(F/L/C)ʼ(T0,T1ʼ)------
void MeasureFLC_init(void)
{
    Timer0_Num = 0;
    Timer1_Num = 0;
    TMOD = 0x51;  //T0ʱ,T1
    TH0  = 0x3c;  //T0ֵ8λ(ʱ50ms)
    TL0  = 0xb0;  //T0ֵ8λ
    TH1  = 0x3c;  //T1ֵ8λ(50000)
    TL1  = 0xb0;  //T1ֵ8λ
    TR0  = 1;  //T0
    TR1  = 1;  //T1
    ET0  = 1;  //T0жϿ
    ET1  = 1;  //T1жϿ
    EA = 1;    //жϿ
}
//--------L/Cֵ--------
void LC_Calculate(void)
{
    float mes;
    mes = (float)Frequency0/(float)Frequency1;  //Ƶʱ
    mes *= mes;  //ƽֵ
    if(mes < 1)  //ȡֵ
    {
        mes = 1 - mes;
    }
    else
    {
        mes -= 1;
    }
    Cx = 100 * mes * Cref;   //㱻ֵ(ȷ0.1pF)
    if((Cx%10) >= 5)  //
    {
        Cx = Cx/10 + 1;
    }
    else
    {
        Cx = Cx/10;
    }
    Lx = mes * Lref * 1000;  //㱻ֵ(ȷ0.01uH)
    if((Lx%10) >= 5)  //
    {
        Lx = Lx/10 + 1;
    }
    else
    {
        Lx = Lx/10;
    }
    if(Frequency1<50)    //ֹʱʾֵ
    {
        Lx = 0;
    }
}
//----ԶУ(ֵ)-------
void Auto_Calib(void)
{
    u8 i;
    if((K1_F_LC != 0) || (K2_L_C != 0))  //жK1,K2ĳʼλ
    {
        LCD_Clear();
        LCD_Write_String(0,0,"Auto Calib fail!");
        if((K1_F_LC == 1) && (K2_L_C == 1))
        {
            LCD_Write_String(1,0,"Need up K1 & K2 ");
        }
        else
        {
            if(K1_F_LC == 1)
            {
                LCD_Write_String(1,0,"   Need up K1   ");
            }
            else
            {
                LCD_Write_String(1,0,"   Need up K2   ");
            }
        }
        while((K1_F_LC == 1) || (K2_L_C == 1));  //ȴK1,K2׼ȷʼλ
        for(i=0; i<20; i++)
        {
            Delay_ms(75);  //ʱ1.5,.
        }
    }
    LC_Calculate();
	Delay_ms(150);
    Lref = (Cx/Cref + 1) * 100;  //׼ֵ(λuH)
    Frequency0 = Frequency1;
}
//-------ȡ--------
void Get_Key(void)
{
    if(K4_FLC_EC == 0)  //=0(ť)
    {
        Delay_ms(50);
        if(K4_FLC_EC == 0)
        {
            FLC_EC_Flag = ~FLC_EC_Flag; //־ȡ
            if(FLC_EC_Flag == 0)  //=0,ǲFLC
            {
                EX0 = 0;        //رղݵĹ(ⲿж0)
                MeasureFLC_init();  //(F/L/C)ʼ(T0,T1ʼ)
            }
            else  //,ǲ.
            {
                TR0 = 0;  //T0
                ET0 = 0;  //T0жϹ
            }
        }
    }
    if(K5_Calib == 0)  //=0(ť)(ֹУ)
    {
        Delay_ms(50);  //ʱ50sm,
        if(K5_Calib == 0)
        {
            if((K1_F_LC == 0) && (K2_L_C == 0))  //K1,K2ڲλ
            {
                Frequency0 = Frequency1;
            }
        }
    }
}
//-------Եݳʼ(T0,T1ⲿжϳʼ)-------
void MeasureElec_init(void)
{
    u8 i;
    ECx_H = 0;
    ECx_L = 0;
    TR1 = 0;
    ET1 = 0;
    EX0 = 0;  //ⲿж
    Dischg = 0;  //ŵ
    Delay_ms(180);
    Delay_ms(200);
    Dischg = 1;  //
    Timer1_Num = 0;
    TMOD = 0x11;  //T0,T1ʱ
    TH1  = 0x3c;  //T1ֵ8λ(ʱ50ms)
    TL1  = 0xb0;  //T1ֵ8λ
    TR1  = 1;  //T1
    ET1  = 1;  //T1жϿ
    IT0  = 1;  //½ش
    EX0  = 1;  //ⲿжϿ
    EA   = 1;  //жϿ
    for(i=0; i<65; i++)  //ʱ1.3s,ȴ
    {
        Delay_ms(20);
        if(K4_FLC_EC == 0)  //ڼK4
        {
            Delay_ms(20);
            if(K4_FLC_EC == 0)
            {
                break;  //ֹ
            }
        }
    }
    EX0    =    0;    //ⲿжϹ
    Dischg =    0;    //ŵ
}
//--------ʱ0жϴ---------
void Timer0_interrupt(void) interrupt 1
{
    TH0  = 0x3c;  //װT0ֵ8λ(ʱ50ms)
    TL0  = 0xb0;  //װT0ֵ8λ
    Timer0_Num++; //T0ƴۼ
    if(Timer0_Num >= T0_times)  //T0ƴ=T0Ԥֵ(F=20(1s),LC=10(0.5s))
    {
        TR0 = 0;  //T0
        TF0 = 0;  //T0־
        TR1 = 0;  //T1
        TF1 = 0;  //T1־
        Frequency1 = 50000*Timer1_Num + ((u16)((TH1<<8)+TL1)-0x3cb0);
        //Ƶֵ(Frequency1)
        Timer0_Num = 0;  //T0ƴ
        Timer1_Num = 0;  //T1ƴ
        TH0  = 0x3c;  //װT0ֵ8λ(ʱ50ms)
        TL0  = 0xb0;  //װT0ֵ8λ
        TH1  = 0x3c;  //װT1ֵ8λ(50000)
        TL1  = 0xb0;  //װT1ֵ8λ
        TR0  = 1;  //T0
        TR1  = 1;  //T1
    }
}
//------ʱ1жϴ-------
void Timer1_interrupt(void) interrupt 3
{
    TH1  = 0x3c;  //װT1ֵ8λ(ʱ50ms,50000)
    TL1  = 0xb0;  //װT1ֵ8λ
    Timer1_Num++; //T1ƴۼ
}
//-------ⲿINT0жϴ--------
void INT0_Interrupt(void) interrupt 0
{
    if(Measure_Flag==4)
    {
        ECx_L = (50000*Timer1_Num + ((u16)((TH1<<8)+TL1)-0x3cb0))*100/2000;
        //ֵ(ȷ0.01uF)
        if((ECx_L-2)>=0)
        {
            ECx_L -= 2;  //
        }
    }
    if(Measure_Flag==5)
    {
        ECx_H = (50000*Timer1_Num + ((u16)((TH1<<8)+TL1)-0x3cb0))*10/100;
        //ֵ(ȷ0.1uF)
        if((ECx_H-4)>=0)
        {
            ECx_H -= 4;   //
        }
    }
}
//-----------
void Main(void)
{
    u8 i;
    u8 clear;           //־λ,תҪ
    Measure_Flag = 0;
    FLC_EC_Flag  = 0;   //ĬϲFLC
    T0_times     = 10;
    Timer0_Num   = 0;
    Timer1_Num   = 0;
    Frequency0   = 169500;
	//׼Ƶʵһ(׼Ƶ:L=100uH,C=2200pFʱƵ,=339000Hz)
    Frequency1   = 0;
    LCD1602_Init();
    MeasureFLC_init();
    LCD_Write_String(0,0,"  L.C.F  Meter   ");
    LCD_Write_String(1,0,"   2015-08-01  ");
    for(i=0; i<20; i++)
    {
        Delay_ms(150);  //ʾ3
    }
    Auto_Calib();
    while(1)
    {
        Get_Key();               //ɨ
        Delay_ms(70);            //ʱʹлȶ
        clear = Measure_Flag;    //ͱ־
        Get_Measure_Flag();      //ȡͱ־
        if(clear != Measure_Flag)
        {
            LCD_Clear();
        }
        switch(Measure_Flag)    //ݲ־㲢ʾ
        {
        case    1:              //
        {
            LC_Calculate();
            LCD_Write_String(0,0,"Cx= ");
            LCD_Write_LongPoint(0,4,8,1,Cx);
            LCD_Write_String(0,13," pF");
            LCD_Write_String(1,0,"freq=  ");
            LCD_Write_Long(1,6,6,Frequency1*2);
            LCD_Write_String(1,13," Hz");
            break;
        }
        case    2:              //
        {
            LC_Calculate();
            LCD_Write_String(0,0,"Lx= ");
            LCD_Write_LongPoint(0,4,8,2,Lx);
            LCD_Write_String(0,13," uH");
            LCD_Write_String(1,0,"freq= ");
            LCD_Write_Long(1,6,6,Frequency1*2);
            LCD_Write_String(1,13," Hz");
            break;
        }
        case    3:              //Ƶ
        {
            LCD_Write_String(0,0,"   Meas_Freq   ");
            LCD_Write_String(1,0,"Freq= ");
            if(Frequency1<40)  //ƵС40Hz
            {
                Frequency1=0;  //ʾ
            }
            LCD_Write_Long(1,6,6,Frequency1);
            LCD_Write_String(1,13," Hz");
            break;
        }
        case    4:              //С
        {
            LCD_Write_String(0,0,"0.47uF<CEx<600uF");
            LCD_Write_String(1,0,"CEx=  ");
            LCD_Write_String(1,14,"uF");
            LCD_Write_LongPoint(1,6,5,2,ECx_L);
            MeasureElec_init();
            break;
        }
        case    5:              //
        {
            LCD_Write_String(0,0,"220uF< CEx <12mF");
            LCD_Write_String(1,0,"CEx=  ");
            LCD_Write_String(1,14,"uF");
            LCD_Write_LongPoint(1,6,6,1,ECx_H);
            MeasureElec_init();
            break;
        }
        default:
            break;
        }
    }
}
